package com.ruoyi.system.utils;

import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;
import java.security.Key;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import javax.crypto.SecretKey;
import com.ruoyi.common.core.utils.StringUtils;

public class AesUtils
{
    public static String encrypt(final String plaintext) {
        if (StringUtils.isEmpty(plaintext)) {
            return null;
        }
        if (plaintext.endsWith("@gn")) {
            return plaintext;
        }
        final byte[] iv = generateIVFixation();
        final SecretKeySpec keySpec = generateKey();
        final byte[] cipherText = encrypt(plaintext, keySpec, iv);
        if (cipherText == null) {
            return null;
        }
        return bytesToHex(cipherText) + "@gn";
    }
    
    public static String decrypt(final String cipherText) {
        if (StringUtils.isEmpty(cipherText) || !cipherText.endsWith("@gn")) {
            return cipherText;
        }
        final byte[] iv = generateIVFixation();
        final SecretKeySpec keySpec = generateKey();
        return decrypt(hexStringToByteArray(cipherText.replace("@gn", "")), keySpec, iv);
    }
    
    public static SecretKeySpec generateKey() {
        final byte[] keyBytes = hexStringToByteArray("888762A983741DBC8D05B34EF501A7E8");
        return new SecretKeySpec(keyBytes, "AES");
    }
    
    public static byte[] generateIVFixation() {
        final byte[] fixedIV = hexStringToByteArray("0DE102F8524666EDB3628FF31F11B465");
        return fixedIV;
    }
    
    public static byte[] encrypt(final String plaintext, final SecretKey key, final byte[] iv) {
        try {
            final Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            final IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
            cipher.init(1, key, ivParameterSpec);
            final byte[] cipherText = cipher.doFinal(plaintext.getBytes());
            return cipherText;
        }
        catch (final Exception ignore) {
            return null;
        }
    }
    
    public static String decrypt(final byte[] cipherText, final SecretKey key, final byte[] iv) {
        try {
            final Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            final IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
            cipher.init(2, key, ivParameterSpec);
            final byte[] plainText = cipher.doFinal(cipherText);
            return new String(plainText);
        }
        catch (final Exception ignore) {
            return null;
        }
    }
    
    public static byte[] hexStringToByteArray(final String s) {
        final int len = s.length();
        final byte[] data = new byte[len / 2];
        for (int i = 0; i < len; i += 2) {
            data[i / 2] = (byte)((Character.digit(s.charAt(i), 16) << 4) + Character.digit(s.charAt(i + 1), 16));
        }
        return data;
    }
    
    public static byte[] generateIV() throws NoSuchAlgorithmException {
        final SecureRandom random = SecureRandom.getInstanceStrong();
        final byte[] iv = new byte[16];
        random.nextBytes(iv);
        return iv;
    }
    
    public static String bytesToHex(final byte[] bytes) {
        final StringBuilder result = new StringBuilder();
        for (final byte b : bytes) {
            result.append(String.format("%02X", b));
        }
        return result.toString();
    }
    
    public static String getData(final String val, final String symbol, final int subscript) {
        final String[] vals = val.split(symbol);
        return vals[subscript];
    }
    
    public static void main(final String[] args) {
        System.out.println("解密: " + decrypt("29F9A9898587BEFC29D9B6CB0A3D5C50779352CC005864D81CE19CBA12EC1590@gn"));
    }
}
